> ## Documentation Index
> Fetch the complete documentation index at: https://docs.topsort.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Campaign

> Create a new offsite campaign.



## OpenAPI

````yaml /openapi.json post /public/v1/offsite-ads/campaigns
openapi: 3.1.0
info:
  title: Topsort Endpoints v2 API Reference
  description: >
    In order for a storefront to be able to run auctions in Topsort and report
    auction-related events back to Topsort,

    both the `/v2/auctions` and `/v2/events` endpoints must be integrated.

    Below are the endpoint and model definitions for each.
  contact:
    email: wicha@topsort.com
  license:
    name: Apache 2.0
    url: http://www.apache.org/licenses/LICENSE-2.0.html
  x-logo:
    url: https://assets.topsort.com/Topsort_logo_icon_dark.svg
    backgroundColor: '#fff'
    altText: Topsort
  version: 2.0.0
servers:
  - url: https://api.topsort.com
    description: Base API URL
security: []
tags:
  - name: Auctions
    description: >-
      An auction determines which products should be promoted based on the
      vendors' bids.
  - name: Events
    description: >-
      Events are sent to Topsort as part of the attribution and reporting
      journey.
  - name: Toptimize
    description: >
      An out-of-the-box solution for prediction, ranking, retrieval, and other
      elements of ad selection.
  - name: Toppie API
    description: Toppie management API.
  - name: Campaign API
    description: Full-featured campaign management API for banners and sponsored listings.
  - name: Catalog API
    description: Products catalog management API.
  - name: Billing API
    description: Marketplace and Vendor Billing management API.
  - name: Reporting API
    description: Marketplace, Vendor, Campaign, and product reporting API.
  - name: Invitation API
    description: Vendor invitations management API.
  - name: User API
    description: User management API.
  - name: Webhooks API
    description: Webhooks API that allows event-driven automation.
  - name: Assets API
    description: Assets management API.
  - name: Segments Service
    description: Segments Service.
  - name: Forecasting Service
    description: Toptimize Forecasting Service.
  - name: Offsite Ads API
    description: Offsite Ads API that allows to manage offsite ads campaigns.
  - name: Media API
    description: Ad configuration API.
paths:
  /public/v1/offsite-ads/campaigns:
    post:
      tags:
        - Offsite Ads API
      summary: Create Campaign
      description: Create a new offsite campaign.
      operationId: create_offsite_campaign
      parameters:
        - name: vendor_id
          in: query
          required: true
          schema:
            type: string
            description: The ID of the vendor to create the campaign for.
          description: The ID of the vendor to create the campaign for.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/Advanced_APIs_CreateOffsiteCampaignRequest'
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Advanced_APIs_JobResponseBase'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Advanced_APIs_HTTPValidationError'
      security:
        - Advanced_APIs_HTTPBearer: []
components:
  schemas:
    Advanced_APIs_CreateOffsiteCampaignRequest:
      properties:
        dsp:
          $ref: '#/components/schemas/Advanced_APIs_PublicDsp'
          description: The DSP to create the campaign for.
        name:
          type: string
          maxLength: 35
          pattern: "^[^;\"'<>\\#\\|,\\\r\\\n\\\\]*[^;\"'<>\\#\\|,\\\r\\\n\\\\\\s][^;\"'<>\\#\\|,\\\r\\\n\\\\]*$"
          title: Name
          description: The name of the campaign
        startDate:
          type: string
          format: date-time
          title: Startdate
        endDate:
          type: string
          format: date-time
          title: Enddate
        budget:
          type: integer
          exclusiveMaximum: 2000000000
          exclusiveMinimum: 0
          format: int64
          title: Budget
          description: >-
            The amount of money in the budget in minor units of currency
            according to ISO 4217.
          examples:
            - 1000
        locationIds:
          items:
            type: string
          type: array
          minItems: 1
          title: Locationids
          description: >-
            The DSP-native location IDs to target. Retrieve available IDs via
            GET /offsite-ads/marketplace/geolocations and use the values from
            dspLocationIds for the target DSP. Reference: Google Ads geo targets
            (https://developers.google.com/google-ads/api/data/geotargets), Meta
            region IDs
            (https://developers.facebook.com/docs/marketing-api/audiences/reference/targeting-search#regions).
          examples:
            - - '123456'
        productIds:
          title: Productids
          description: >-
            The product ids to target. These are the product ids from the
            catalog. If not provided, all products will be targeted.
          examples:
            - - prod1
              - prod2
              - prod3
              - prod4
              - prod5
          oneOf:
            - items:
                type: string
              type: array
              minItems: 5
            - type: 'null'
        audienceIds:
          title: Audienceids
          description: >-
            The audience ids to target. These are the audience ids from each DSP
            platform. Currently, only one audience is supported. If not
            provided, no audience will be targeted.
          examples:
            - - '123456'
          oneOf:
            - items:
                type: string
              type: array
              maxItems: 1
            - type: 'null'
      type: object
      required:
        - dsp
        - name
        - budget
        - locationIds
      title: CreateOffsiteCampaignRequest
    Advanced_APIs_JobResponseBase:
      properties:
        jobId:
          type: string
          format: uuid
          title: Jobid
          description: The unique identifier for the queued job.
      type: object
      required:
        - jobId
      title: JobResponseBase
    Advanced_APIs_HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/Advanced_APIs_ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    Advanced_APIs_PublicDsp:
      type: string
      enum:
        - google_ads
        - meta
      title: PublicDsp
      description: The DSP to scope the requested operation or to filter the response by.
    Advanced_APIs_ValidationError:
      properties:
        loc:
          items:
            oneOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    Advanced_APIs_HTTPBearer:
      type: http
      description: >-
        A valid API key generated in Topsort's UI. Use the TSE API key if
        calling auctions or events API, otherwise use the TSC API key.
      scheme: bearer

````